﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using Infragistics.Windows;

namespace ChartInfoStrips
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("XAxis", typeof(string));
            dt.Columns.Add("YAxis", typeof(double));

            //dt.Rows.Add("-5", 0.0025);
            //dt.Rows.Add("-4", 0.0015);
            //dt.Rows.Add("-3", 0.001);
            //dt.Rows.Add("-2", 0.0075);
            //dt.Rows.Add("-1", 0.035);

            //dt.Rows.Add("1", 0.0105);
            //dt.Rows.Add("2", 0.0105);
            //dt.Rows.Add("3", 0.006);
            //dt.Rows.Add("4", 0.005);
            //dt.Rows.Add("5", 0.007);
            //dt.Rows.Add("6", 0.009);
            //dt.Rows.Add("7", 0.0085);
            //dt.Rows.Add("8", 0.009);

            //dt.Rows.Add("-4", 0.007);
            //dt.Rows.Add("-3", 0.01);
            //dt.Rows.Add("-2", 0.013);
            //dt.Rows.Add("-1", 0.015);

            //dt.Rows.Add("OE", 0.014);

            //dt.Rows.Add("1", 0.0095);
            //dt.Rows.Add("2", 0.01);

            //dt.Rows.Add("-6", 0.01);
            //dt.Rows.Add("-5", 0.01);
            //dt.Rows.Add("-4", 0.01);
            //dt.Rows.Add("-3", 0.01);
            //dt.Rows.Add("-2", 0.01);
            //dt.Rows.Add("-1", 0.01);

            //dt.Rows.Add("1", 0.01);
            //dt.Rows.Add("2", 0.01);
            //dt.Rows.Add("3", 0.01);
            //dt.Rows.Add("4", 0.01);

            Random random = new Random();
            double max = 0.2;
            double min = -0.1;
            for (int i = 0; i < 252; i++)
                dt.Rows.Add(i.ToString(), random.NextDouble() * (max - min) + min);

            xAxis.ItemsSource = dt.DefaultView;

            LineSeries series1 = new LineSeries();
            series1.ItemsSource = dt.DefaultView;
            series1.ValueMemberPath = "YAxis";
            series1.XAxis = xAxis;
            series1.YAxis = yAxis;
            series1.MarkerType = MarkerType.None;
            series1.Title = "My Line Series"
            xamDataChart1.Series.Add(series1);

            //Black line at the origin of the Y Axis
            ValueOverlay origin = new ValueOverlay();
            origin.Axis = yAxis;
            origin.Value = 0.0;
            origin.Thickness = 1.0;
            origin.Brush = new SolidColorBrush(Colors.Black);
            origin.LegendItemVisibility = Visibility.Collapsed;
            xamDataChart1.Series.Add(origin);
        }

        private void xamDataChart_RefreshCompleted(object sender, EventArgs e)
        {
            if (xamDataChart1.Series.Any())
            {
                // doesn't really matter which series we use for this
                Series series = xamDataChart1.Series[0];
                if (series.RootCanvas != null)
                {
                    HorizontalAxisLabelPanel axisPanel = (HorizontalAxisLabelPanel)Utilities.GetDescendantFromType<HorizontalAxisLabelPanel>(xamDataChart1, false, SearchHorizontalAxisCallback);
                }
            }
        }

        private bool SearchHorizontalAxisCallback(HorizontalAxisLabelPanel dependencyObject)
        {
            // doesn't really matter which series we use for this
            Series series = xamDataChart1.Series[0];
            if (series.RootCanvas != null)
            {
                double pixel = yAxis.ScaleValue(0.0);

                // get the handle of the window
                HwndSource windowhandlesource = PresentationSource.FromVisual(this) as HwndSource;

                // work out the current screen's DPI
                Matrix screenmatrix = windowhandlesource.CompositionTarget.TransformToDevice;
                double dpiX = screenmatrix.M11;
                double dpiY = screenmatrix.M22;

                // move the X axis to the correct location
                double axisHeightAdjustment = series.RootCanvas.ActualHeight - pixel;
                dependencyObject.RenderTransform = new TranslateTransform(0.0, -axisHeightAdjustment);
            }

            return false;
        }
    }
}
